#! /usr/bin/env python
# -*- coding: iso-8859-1 -*-

## Copyright 1999-2003 by LivingLogic AG, Bayreuth, Germany.
## Copyright 1999-2003 by Walter Drwald
##
## All Rights Reserved
##
## Permission to use, copy, modify, and distribute this software and its documentation
## for any purpose and without fee is hereby granted, provided that the above copyright
## notice appears in all copies and that both that copyright notice and this permission
## notice appear in supporting documentation, and that the name of LivingLogic AG or
## the author not be used in advertising or publicity pertaining to distribution of the
## software without specific, written prior permission.
##
## LIVINGLOGIC AG AND THE AUTHOR DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
## INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
## LIVINGLOGIC AG OR THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
## DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
## IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR
## IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

"""
"""

__version__ = tuple(map(int, "$Revision: 1.1.2.2.2.4 $"[11:-2].split(".")))
# $Source: /data/cvsroot/LivingLogic/xist/_xist/ns/struts_config11.py,v $

from ll.xist import xsc
import struts_config as struts_config10

class DocType(xsc.DocType):
	def __init__(self):
		xsc.DocType.__init__(
			self,
			'struts-config PUBLIC '
			'"-//Apache Software Foundation//DTD Struts Configuration 1.1//EN" '
			'"http://jakarta.apache.org/struts/dtds/struts-config_1_1.dtd"'
		)

class data_sources(struts_config10.data_sources):
	name = "data-sources"

class data_source(struts_config10.data_source):
	attrHandlers = {"className": xsc.TextAttr, "key": xsc.TextAttr, "type": xsc.TextAttr}
	name = "data-source"

class set_property(struts_config10.set_property):
	name = "set-property"

class struts_config(struts_config10.struts_config):
	name = "struts-config"

class action(xsc.Element):
	"""
	<par>The "action" element describes an ActionMapping object that is to be used
	to process a request for a specific module-relative URI.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "attribute": xsc.TextAttr, "className": xsc.TextAttr, "forward": xsc.TextAttr, "include": xsc.TextAttr, "input": xsc.TextAttr, "name": xsc.TextAttr, "parameter": xsc.TextAttr, "path": xsc.TextAttr, "prefix": xsc.TextAttr, "roles": xsc.TextAttr, "scope": xsc.TextAttr, "suffix": xsc.TextAttr, "type": xsc.TextAttr, "unknown": xsc.TextAttr, "validate": xsc.TextAttr}

class action_mappings(xsc.Element):
	"""
	<par>The "action-mappings" element describes a set of ActionMapping objects
	[org.apache.struts.action.ActionMapping] that are available to process
	requests matching the url-pattern our ActionServlet registered with the
	container. The individual ActionMappings are configured through nested
	<pyref class="action"><class>action</class></pyref> elements.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "type": xsc.TextAttr}
	name = "action-mappings"

class controller(xsc.Element):
	"""
	<par>The "controller" element describes the ControllerConfig bean
	[org.apache.struts.config.ControllerConfig] that encapsulates
	an application module's runtime configuration.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "bufferSize": xsc.TextAttr, "className": xsc.TextAttr, "contentType": xsc.TextAttr, "debug": xsc.TextAttr, "forwardPattern": xsc.TextAttr, "inputForward": xsc.TextAttr, "locale": xsc.TextAttr, "maxFileSize": xsc.TextAttr, "memFileSize": xsc.TextAttr, "multipartClass": xsc.TextAttr, "nocache": xsc.TextAttr, "pagePattern": xsc.TextAttr, "processorClass": xsc.TextAttr, "tempDir": xsc.TextAttr}

class data_source(xsc.Element):
	"""
	<par>The "data-source" element describes a DataSource object [JDBC 2.0 Standard
	Extension] that will be instantiated, configured, and made available as a
	servlet context attribute (or "application-scope bean"). Any object can be
	specified so long as it implements [javax.sql.DataSource] and can be
	configured entirely from JavaBean properties.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "className": xsc.TextAttr, "key": xsc.TextAttr, "type": xsc.TextAttr}
	name = "data-source"

class data_sources(xsc.Element):
	"""
	<par>The "data-sources" element describes a set of DataSource objects [JDBC 2.0
	Standard Extension]. The individual DataSource objects are configured through
	nested <pyref class="data_source"><class>data_source</class></pyref> elements.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "data-sources"

class description(xsc.Element):
	"""
	<par>The "description" element contains descriptive (paragraph length) text
	about the surrounding element, suitable for use in GUI tools.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}

class display_name(xsc.Element):
	"""
	<par>The "display-name" element contains a short (one line) description of
	the surrounding element, suitable for use in GUI tools.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "display-name"

class exception(xsc.Element):
	"""
	<par>The "exception" element registers an ExceptionHandler for an exception type.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "bundle": xsc.TextAttr, "className": xsc.TextAttr, "handler": xsc.TextAttr, "key": xsc.TextAttr, "path": xsc.TextAttr, "scope": xsc.TextAttr, "type": xsc.TextAttr}

class form_bean(xsc.Element):
	"""
	<par>The "form-bean" element describes a particular form bean, which is a
	JavaBean that implements the org.apache.struts.action.ActionForm
	class.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "className": xsc.TextAttr, "dynamic": xsc.TextAttr, "name": xsc.TextAttr, "type": xsc.TextAttr}
	name = "form-bean"

class form_beans(xsc.Element):
	"""
	<par>The "form-beans" element describes the set of form bean descriptors for this
	application module.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "type": xsc.TextAttr}
	name = "form-beans"

class form_property(xsc.Element):
	"""
	<par>The "form-property" element describes a JavaBean property that can be used to
	configure an instance of a DynaActionForm or a subclass thereof. This element
	is only utilized when the "type" attribute of the enclosing "form-bean" element
	is [org.apache.struts.action.DynaActionForm] or a subclass of DynaActionForm. If
	a custom DynaActionForm subclass is used, then the "dynamic" attribute of the
	enclosing <pyref class="form_bean"><class>form_bean</class></pyref> element must be set to "true". Since Struts 1.1.</par>
	"""
	empty = False
	attrHandlers = {"className": xsc.TextAttr, "initial": xsc.TextAttr, "name": xsc.TextAttr, "size": xsc.TextAttr, "type": xsc.TextAttr}
	name = "form-property"

class forward(xsc.Element):
	"""
	<par>The "forward" element describes an ActionForward that is to be made
	available to an Action as a return value. An ActionForward is referenced by
	a logical name and encapsulates a URI. A "forward" element may be used to
	describe both global and local ActionForwards. Global forwards are available
	to all the Action objects in the application module. Local forwards can be
	nested within an <pyref class="action"><class>action</class></pyref> element and only available to an Action object
	when it is invoked through that ActionMapping.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "className": xsc.TextAttr, "contextRelative": xsc.TextAttr, "name": xsc.TextAttr, "path": xsc.TextAttr, "redirect": xsc.TextAttr}

class global_exceptions(xsc.Element):
	"""
	<par>The "global-exceptions" element describes a set of exceptions that might be
	thrown by an Action object. The handling of individual exception types is
	configured through nested exception elements. An <pyref class="action"><class>action</class></pyref> element may
	override a global exception handler by registering a local exception handler
	for the same exception type. Since Struts 1.1.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "global-exceptions"

class global_forwards(xsc.Element):
	"""
	<par>The "global-forwards" element describes a set of ActionForward objects
	[org.apache.struts.action.ActionForward] that are available to all Action
	objects as a return value. The individual ActionForwards are configured
	through nested <pyref class="forward"><class>forward</class></pyref> elements. An <pyref class="action"><class>action</class></pyref> element may override a global
	forward by defining a local <pyref class="forward"><class>forward</class></pyref> of the same name.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "type": xsc.TextAttr}
	name = "global-forwards"

class icon(xsc.Element):
	"""
	<par>The "icon" element contains a small-icon and large-icon element which
	specify the location, relative to the Struts configuration file, for small
	and large images used to represent the surrounding element in GUI tools.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}

class large_icon(xsc.Element):
	"""
	<par>The "large-icon" element specifies the location, relative to the Struts
	configuration file, of a resource containing a large (32x32 pixel)
	icon image.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "large-icon"

class message_resources(xsc.Element):
	"""
	<par>The "message-resources" element describes a MessageResources object with
	message templates for this module.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "className": xsc.TextAttr, "factory": xsc.TextAttr, "key": xsc.TextAttr, "null": xsc.TextAttr, "parameter": xsc.TextAttr}
	name = "message-resources"

class plug_in(xsc.Element):
	"""
	<par>The "plug-in" element specifies the fully qualified class name of a
	general-purpose application plug-in module that receives notification of
	application startup and shutdown events. An instance of the specified class
	is created for each element, and can be configured with nested <pyref class="set_property"><class>set_property</class></pyref>
	elements.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr, "className": xsc.TextAttr}
	name = "plug-in"

class set_property(xsc.Element):
	"""
	<par>The "set-property" element specifies the method name and initial value of
	an additional JavaBean configuration property. When the object representing
	the surrounding element is instantiated, the accessor for the indicated
	property is called and passed the indicated value. The "set-property"
	element is especially useful when a custom subclass is used with
	<pyref class="data_source"><class>data_source</class></pyref>, <pyref class="forward"><class>forward</class></pyref>, <pyref class="action"><class>action</class></pyref>, or <pyref class="plug_in"><class>plug_in</class></pyref> elements. The subclass
	can be passed whatever other properties may be required to configure the
	object without changing how the struts-config is parsed.</par>
	"""
	empty = True
	attrHandlers = {"id": xsc.TextAttr, "property": xsc.TextAttr, "value": xsc.TextAttr}
	name = "set-property"

class small_icon(xsc.Element):
	"""
	<par>The "small-icon" element specifies the location, relative to the Struts
	configuration file, of a resource containing a small (16x16 pixel)
	icon image.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "small-icon"

class struts_config(xsc.Element):
	"""
	<par>The "struts-config" element is the root of the configuration file
	hierarchy, and contains nested elements for all of the other
	configuration settings.</par>
	"""
	empty = False
	attrHandlers = {"id": xsc.TextAttr}
	name = "struts-config"

# this is no "official" struts-config element, but nontheless useful for generating
# the final XML output
class user_struts_config(xsc.Element):
	empty = False
	name = "user-struts-config"

	def convert(self, converter):
		e = xsc.Frag(
			xsc.XML10(),
			u"\n",
			DocType(),
			u"\n",
			struts_config(self.content)
		)
		return e.convert(converter)

# register all the classes we've defined so far
namespace = xsc.Namespace("struts-config_1_1", "... insert URL of DTD ...", vars())
